VERSION 5.00
Begin VB.Form RC4DemoForm 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "RC4 Demo"
   ClientHeight    =   5460
   ClientLeft      =   45
   ClientTop       =   345
   ClientWidth     =   8295
   BeginProperty Font 
      Name            =   "Microsoft Sans Serif"
      Size            =   9.75
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "RC4DemoForm.frx":0000
   LinkTopic       =   "RC4DemoForm"
   MaxButton       =   0   'False
   ScaleHeight     =   5460
   ScaleWidth      =   8295
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdDecrypt 
      Caption         =   "Decrypt"
      Enabled         =   0   'False
      Height          =   495
      Left            =   4680
      TabIndex        =   3
      Top             =   4920
      Width           =   1215
   End
   Begin VB.CommandButton cmdEncrypt 
      Caption         =   "Encrypt"
      Height          =   495
      Left            =   2340
      TabIndex        =   2
      Top             =   4920
      Width           =   1215
   End
   Begin VB.TextBox txtContent 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   4215
      Left            =   240
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   1
      Text            =   "RC4DemoForm.frx":1442
      Top             =   600
      Width           =   7815
   End
   Begin VB.TextBox txtPassphrase 
      Height          =   375
      Left            =   240
      TabIndex        =   0
      Text            =   "This has been willed where willed it must be"
      Top             =   120
      Width           =   7815
   End
End
Attribute VB_Name = "RC4DemoForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private RC4 As New RC4

Private Function FromHex(ByVal HexString As String) As Byte()
    Dim bytPart() As Byte
    Dim lngNext As Long
    
    HexString = Replace$(HexString, vbNewLine, "")
    ReDim bytPart(Len(HexString) \ 2 - 1)
    For lngNext = 1 To Len(HexString) Step 2
        bytPart((lngNext - 1) \ 2) = CByte("&H0" & Mid$(HexString, lngNext, 2))
    Next
    FromHex = bytPart
End Function

Private Function ToHex(ByRef Content() As Byte) As String
    Dim N As Long
    Dim Col As Long
    
    For N = LBound(Content) To UBound(Content)
        If Col > 60 Then
            ToHex = ToHex & vbNewLine
            Col = 0
        End If
        ToHex = ToHex & Right$("0" & Hex$(Content(N)), 2)
        Col = Col + 2
    Next
    If Col <> 0 Then ToHex = ToHex & vbNewLine
End Function

Private Sub cmdDecrypt_Click()
    Dim strParts() As String
    Dim lngPart As Long
    Dim bytPart() As Byte
    
    strParts = Split(txtContent.Text, "-----" & vbNewLine) 'Will have an empty lefover at the end.
    txtContent.Text = ""
    txtContent.SelStart = 0
    'Caution: Chars outside 0-127 convert differently in different locales:
    RC4.SetSecret StrConv(txtPassphrase.Text, vbFromUnicode)
    For lngPart = 0 To UBound(strParts) - 1
        bytPart = FromHex(strParts(lngPart))
        RC4.CryptBlock bytPart
        txtContent.SelText = bytPart
    Next
    txtContent.SelStart = 0
End Sub

Private Sub cmdEncrypt_Click()
    Dim strFull As String
    Dim lngFullSize As Long
    Dim lngPartSize As Long
    Dim lngNext As Long
    Dim bytPart() As Byte
    
    strFull = txtContent.Text
    txtContent.Text = ""
    txtContent.SelStart = 0
    lngFullSize = Len(strFull)
    lngPartSize = lngFullSize \ 4& 'Let's test this in ~ 4 chunks.
    lngNext = 1
    'Caution: Chars outside 0-127 convert differently in different locales:
    RC4.SetSecret StrConv(txtPassphrase.Text, vbFromUnicode)
    Do Until lngNext > lngFullSize
        bytPart = Mid$(strFull, lngNext, lngPartSize)
        lngNext = lngNext + lngPartSize
        RC4.CryptBlock bytPart
        txtContent.SelText = ToHex(bytPart)
        txtContent.SelText = "-----" & vbNewLine
    Loop
    txtContent.SelStart = 0
    cmdDecrypt.Enabled = True
End Sub
